# 寻找工资最高的人

有这样一个表：

```sql
create table employee
(
    id integer auto_increment primary key,
    name varchar(256),
    department varchar(256),
    salary integer
);
```

下列哪个选项可以找出每个部门工资最高的人，并给出这个人的id，姓名，部门和工资信息？

## 答案

```sql
select l.id, l.name, l.department, l.salary 
from employee as l
    join (select department, max(salary) as salary from employee group by department) as r
        on l.department = r.department and l.salary = r.salary
```

## 选项

### 分组错误

```sql
select id, name, department, salary
from employee
group by department
having salary = max(salary);
```

### 结构错误

```sql
select id, name, department, max(salary)
from employee
group by department;
```

### 结构错误

```sql
select id, name, department, max(salary)
from employee
where salary = max(salary);
```